-- name: [CS] DOB
-- description: DOB from Planet DOB

local E_MODEL_PDOB = smlua_model_util_get_id("pdob_geo")

local TEX_PDOB_ICON = get_texture_info("pdob_icon")

local TEXT_MOD_NAME = "DOB"

local CAP_PDOB = {
    normal = smlua_model_util_get_id("pdobcap_geo"),
    wing = smlua_model_util_get_id("pdobwcap_geo"),
    metal = smlua_model_util_get_id("pdobmcap_geo"),
    metalWing = smlua_model_util_get_id("pdobmwcap_geo")
}

local VOICETABLE_PDOB = {
    [CHAR_SOUND_HOOHOO] = 'silence.mp3',
    [CHAR_SOUND_YAH_WAH_HOO] = { 'dobsfx4.mp3' , 'dobsfx8.mp3' , 'dobsfx7.mp3'},
    [CHAR_SOUND_YAHOO] = 'wha.mp3',
    [CHAR_SOUND_UH] = 'dobsfx3.mp3',
    [CHAR_SOUND_HRMM] = 'dobsfx3.mp3',
    [CHAR_SOUND_WAH2] = 'dobsfx9.mp3',
    [CHAR_SOUND_WHOA] = 'dobsfx8.mp3',
    [CHAR_SOUND_EEUH] = 'dobsfx6.mp3',
    [CHAR_SOUND_ATTACKED] = 'gasp.mp3',
    [CHAR_SOUND_OOOF] = 'dobsfx4.mp3',
    [CHAR_SOUND_OOOF2] = 'dobsfx5.mp3',
    [CHAR_SOUND_HERE_WE_GO] = 'wha.mp3',
    [CHAR_SOUND_IMA_TIRED] = 'silence.mp3',
    [CHAR_SOUND_YAWNING] = 'wha.mp3',
    [CHAR_SOUND_WAAAOOOW] = 'silence.mp3',
    [CHAR_SOUND_HAHA] = 'chord.mp3',
    [CHAR_SOUND_HAHA_2] = 'dobsfx9.mp3',
    [CHAR_SOUND_UH2] = 'dobsfx8.mp3',
    [CHAR_SOUND_UH2_2] = 'silence.mp3',
    [CHAR_SOUND_ON_FIRE] = 'silence.mp3',
    [CHAR_SOUND_DYING] = 'dobsfx5.mp3',
    [CHAR_SOUND_PANTING_COLD] = 'silence.mp3',
    [CHAR_SOUND_PANTING] = 'silence.mp3',
    [CHAR_SOUND_COUGHING1] = 'dobsfx4.mp3',
    [CHAR_SOUND_COUGHING2] = 'dobsfx6.mp3',
    [CHAR_SOUND_COUGHING3] = 'dobsfx4.mp3',
    [CHAR_SOUND_PUNCH_YAH] = 'dobsfx4.mp3',
    [CHAR_SOUND_PUNCH_WAH] = 'dobsfx7.mp3',
    [CHAR_SOUND_PUNCH_HOO] = 'dobsfx4.mp3',
    [CHAR_SOUND_MAMA_MIA] = 'silence.mp3',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'silence.mp3',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { 'wha.mp3' , 'dobsfx9.mp3' , 'dobsfx8.mp3'},
    [CHAR_SOUND_DROWNING] = 'dobsfx5.mp3',
    [CHAR_SOUND_DOH] = 'dobsfx4.mp3',
    [CHAR_SOUND_LETS_A_GO] = 'silence.mp3',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'dobsfx9.mp3',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'wha.mp3'
}

--the game does not like nil sounds

local ANIMTABLE_PDOB = {
    [CHAR_ANIM_SLOW_LEDGE_GRAB] = "CHAR_ANIM_SLOW_LEDGE_GRAB",
    [CHAR_ANIM_FALL_OVER_BACKWARDS] = "CHAR_ANIM_FALL_OVER_BACKWARDS",
    [CHAR_ANIM_BACKWARD_AIR_KB] = "CHAR_ANIM_BACKWARD_AIR_KB",
    [CHAR_ANIM_DYING_ON_BACK] = "CHAR_ANIM_DYING_ON_BACK",
    [CHAR_ANIM_BACKFLIP] = "CHAR_ANIM_BACKFLIP",
    [CHAR_ANIM_CLIMB_UP_POLE] = "CHAR_ANIM_CLIMB_UP_POLE",
    [CHAR_ANIM_GRAB_POLE_SHORT] = "CHAR_ANIM_GRAB_POLE_SHORT",
    [CHAR_ANIM_GRAB_POLE_SWING_PART1] = "CHAR_ANIM_GRAB_POLE_SWING_PART1",
    [CHAR_ANIM_GRAB_POLE_SWING_PART2] = "CHAR_ANIM_GRAB_POLE_SWING_PART2",
    [CHAR_ANIM_HANDSTAND_IDLE] = "CHAR_ANIM_HANDSTAND_IDLE",
    [CHAR_ANIM_HANDSTAND_JUMP] = "CHAR_ANIM_HANDSTAND_JUMP",
    [CHAR_ANIM_START_HANDSTAND] = "CHAR_ANIM_START_HANDSTAND",
    [CHAR_ANIM_RETURN_FROM_HANDSTAND] = "CHAR_ANIM_RETURN_FROM_HANDSTAND",
    [CHAR_ANIM_IDLE_ON_POLE] = "CHAR_ANIM_IDLE_ON_POLE",
    [CHAR_ANIM_A_POSE] = "CHAR_ANIM_A_POSE",
    [CHAR_ANIM_SKID_ON_GROUND] = "CHAR_ANIM_SKID_ON_GROUND",
    [CHAR_ANIM_STOP_SKID] = "CHAR_ANIM_STOP_SKID",
    [CHAR_ANIM_CROUCH_FROM_FAST_LONGJUMP] = "CHAR_ANIM_CROUCH_FROM_FAST_LONGJUMP",
    [CHAR_ANIM_CROUCH_FROM_SLOW_LONGJUMP] = "CHAR_ANIM_CROUCH_FROM_SLOW_LONGJUMP",
    [CHAR_ANIM_FAST_LONGJUMP] = "CHAR_ANIM_FAST_LONGJUMP",
    [CHAR_ANIM_SLOW_LONGJUMP] = "CHAR_ANIM_SLOW_LONGJUMP",
    [CHAR_ANIM_AIRBORNE_ON_STOMACH] = "CHAR_ANIM_AIRBORNE_ON_STOMACH",
    [CHAR_ANIM_WALK_WITH_LIGHT_OBJ] = "CHAR_ANIM_WALK_WITH_LIGHT_OBJ",
    [CHAR_ANIM_RUN_WITH_LIGHT_OBJ] = "CHAR_ANIM_RUN_WITH_LIGHT_OBJ",
    [CHAR_ANIM_SLOW_WALK_WITH_LIGHT_OBJ] = "CHAR_ANIM_SLOW_WALK_WITH_LIGHT_OBJ",
    [CHAR_ANIM_SHIVERING_WARMING_HAND] = "CHAR_ANIM_SHIVERING_WARMING_HAND",
    [CHAR_ANIM_SHIVERING_RETURN_TO_IDLE] = "CHAR_ANIM_SHIVERING_RETURN_TO_IDLE",
    [CHAR_ANIM_SHIVERING] = "CHAR_ANIM_SHIVERING",
    [CHAR_ANIM_CLIMB_DOWN_LEDGE] = "CHAR_ANIM_CLIMB_DOWN_LEDGE",
    [CHAR_ANIM_CREDITS_WAVING] = "CHAR_ANIM_CREDITS_WAVING",
    [CHAR_ANIM_CREDITS_LOOK_UP] = "CHAR_ANIM_CREDITS_LOOK_UP",
    [CHAR_ANIM_CREDITS_RETURN_FROM_LOOK_UP] = "CHAR_ANIM_CREDITS_RETURN_FROM_LOOK_UP",
    [CHAR_ANIM_CREDITS_RAISE_HAND] = "CHAR_ANIM_CREDITS_RAISE_HAND",
    [CHAR_ANIM_CREDITS_LOWER_HAND] = "CHAR_ANIM_CREDITS_LOWER_HAND",
    [CHAR_ANIM_CREDITS_TAKE_OFF_CAP] = "CHAR_ANIM_CREDITS_TAKE_OFF_CAP",
    [CHAR_ANIM_CREDITS_START_WALK_LOOK_UP] = "CHAR_ANIM_CREDITS_START_WALK_LOOK_UP",
    [CHAR_ANIM_CREDITS_LOOK_BACK_THEN_RUN] = "CHAR_ANIM_CREDITS_LOOK_BACK_THEN_RUN",
    [CHAR_ANIM_FINAL_BOWSER_RAISE_HAND_SPIN] = "CHAR_ANIM_FINAL_BOWSER_RAISE_HAND_SPIN",
    [CHAR_ANIM_FINAL_BOWSER_WING_CAP_TAKE_OFF] = "CHAR_ANIM_FINAL_BOWSER_WING_CAP_TAKE_OFF",
    [CHAR_ANIM_CREDITS_PEACE_SIGN] = "CHAR_ANIM_CREDITS_PEACE_SIGN",
    [CHAR_ANIM_STAND_UP_FROM_LAVA_BOOST] = "CHAR_ANIM_STAND_UP_FROM_LAVA_BOOST",
    [CHAR_ANIM_FIRE_LAVA_BURN] = "CHAR_ANIM_FIRE_LAVA_BURN",
    [CHAR_ANIM_WING_CAP_FLY] = "CHAR_ANIM_WING_CAP_FLY",
    [CHAR_ANIM_HANG_ON_OWL] = "CHAR_ANIM_HANG_ON_OWL",
    [CHAR_ANIM_LAND_ON_STOMACH] = "CHAR_ANIM_LAND_ON_STOMACH",
    [CHAR_ANIM_AIR_FORWARD_KB] = "CHAR_ANIM_AIR_FORWARD_KB",
    [CHAR_ANIM_DYING_ON_STOMACH] = "CHAR_ANIM_DYING_ON_STOMACH",
    [CHAR_ANIM_SUFFOCATING] = "CHAR_ANIM_SUFFOCATING",
    [CHAR_ANIM_COUGHING] = "CHAR_ANIM_COUGHING",
    [CHAR_ANIM_THROW_CATCH_KEY] = "CHAR_ANIM_THROW_CATCH_KEY",
    [CHAR_ANIM_DYING_FALL_OVER] = "CHAR_ANIM_DYING_FALL_OVER",
    [CHAR_ANIM_IDLE_ON_LEDGE] = "CHAR_ANIM_IDLE_ON_LEDGE",
    [CHAR_ANIM_FAST_LEDGE_GRAB] = "CHAR_ANIM_FAST_LEDGE_GRAB",
    [CHAR_ANIM_HANG_ON_CEILING] = "CHAR_ANIM_HANG_ON_CEILING",
    [CHAR_ANIM_PUT_CAP_ON] = "CHAR_ANIM_PUT_CAP_ON",
    [CHAR_ANIM_TAKE_CAP_OFF_THEN_ON] = "CHAR_ANIM_TAKE_CAP_OFF_THEN_ON",
    [CHAR_ANIM_QUICKLY_PUT_CAP_ON] = "CHAR_ANIM_QUICKLY_PUT_CAP_ON",
    [CHAR_ANIM_HEAD_STUCK_IN_GROUND] = "CHAR_ANIM_HEAD_STUCK_IN_GROUND",
    [CHAR_ANIM_GROUND_POUND_LANDING] = "CHAR_ANIM_GROUND_POUND_LANDING",
    [CHAR_ANIM_TRIPLE_JUMP_GROUND_POUND] = "CHAR_ANIM_TRIPLE_JUMP_GROUND_POUND",
    [CHAR_ANIM_START_GROUND_POUND] = "CHAR_ANIM_START_GROUND_POUND",
    [CHAR_ANIM_GROUND_POUND] = "CHAR_ANIM_GROUND_POUND",
    [CHAR_ANIM_BOTTOM_STUCK_IN_GROUND] = "CHAR_ANIM_BOTTOM_STUCK_IN_GROUND",
    [CHAR_ANIM_IDLE_WITH_LIGHT_OBJ] = "CHAR_ANIM_IDLE_WITH_LIGHT_OBJ",
    [CHAR_ANIM_JUMP_LAND_WITH_LIGHT_OBJ] = "CHAR_ANIM_JUMP_LAND_WITH_LIGHT_OBJ",
    [CHAR_ANIM_JUMP_WITH_LIGHT_OBJ] = "CHAR_ANIM_JUMP_WITH_LIGHT_OBJ",
    [CHAR_ANIM_FALL_LAND_WITH_LIGHT_OBJ] = "CHAR_ANIM_FALL_LAND_WITH_LIGHT_OBJ",
    [CHAR_ANIM_FALL_WITH_LIGHT_OBJ] = "CHAR_ANIM_FALL_WITH_LIGHT_OBJ",
    [CHAR_ANIM_FALL_FROM_SLIDING_WITH_LIGHT_OBJ] = "CHAR_ANIM_FALL_FROM_SLIDING_WITH_LIGHT_OBJ",
    [CHAR_ANIM_SLIDING_ON_BOTTOM_WITH_LIGHT_OBJ] = "CHAR_ANIM_SLIDING_ON_BOTTOM_WITH_LIGHT_OBJ",
    [CHAR_ANIM_STAND_UP_FROM_SLIDING_WITH_LIGHT_OBJ] = "CHAR_ANIM_STAND_UP_FROM_SLIDING_WITH_LIGHT_OBJ",
    [CHAR_ANIM_RIDING_SHELL] = "CHAR_ANIM_RIDING_SHELL",
    [CHAR_ANIM_WALKING] = "CHAR_ANIM_WALKING",
    [CHAR_ANIM_FORWARD_FLIP] = "CHAR_ANIM_FORWARD_FLIP",
    [CHAR_ANIM_JUMP_RIDING_SHELL] = "CHAR_ANIM_JUMP_RIDING_SHELL",
    [CHAR_ANIM_LAND_FROM_DOUBLE_JUMP] = "CHAR_ANIM_LAND_FROM_DOUBLE_JUMP",
    [CHAR_ANIM_DOUBLE_JUMP_FALL] = "CHAR_ANIM_DOUBLE_JUMP_FALL",
    [CHAR_ANIM_SINGLE_JUMP] = "CHAR_ANIM_SINGLE_JUMP",
    [CHAR_ANIM_LAND_FROM_SINGLE_JUMP] = "CHAR_ANIM_LAND_FROM_SINGLE_JUMP",
    [CHAR_ANIM_AIR_KICK] = "CHAR_ANIM_AIR_KICK",
    [CHAR_ANIM_DOUBLE_JUMP_RISE] = "CHAR_ANIM_DOUBLE_JUMP_RISE",
    [CHAR_ANIM_START_FORWARD_SPINNING] = "CHAR_ANIM_START_FORWARD_SPINNING",
    [CHAR_ANIM_THROW_LIGHT_OBJECT] = "CHAR_ANIM_THROW_LIGHT_OBJECT",
    [CHAR_ANIM_FALL_FROM_SLIDE_KICK] = "CHAR_ANIM_FALL_FROM_SLIDE_KICK",
    [CHAR_ANIM_BEND_KNESS_RIDING_SHELL] = "CHAR_ANIM_BEND_KNESS_RIDING_SHELL",
    [CHAR_ANIM_LEGS_STUCK_IN_GROUND] = "CHAR_ANIM_LEGS_STUCK_IN_GROUND",
    [CHAR_ANIM_GENERAL_FALL] = "CHAR_ANIM_GENERAL_FALL",
    [CHAR_ANIM_GENERAL_LAND] = "CHAR_ANIM_GENERAL_LAND",
    [CHAR_ANIM_BEING_GRABBED] = "CHAR_ANIM_BEING_GRABBED",
    [CHAR_ANIM_GRAB_HEAVY_OBJECT] = "CHAR_ANIM_GRAB_HEAVY_OBJECT",
    [CHAR_ANIM_SLOW_LAND_FROM_DIVE] = "CHAR_ANIM_SLOW_LAND_FROM_DIVE",
    [CHAR_ANIM_FLY_FROM_CANNON] = "CHAR_ANIM_FLY_FROM_CANNON",
    [CHAR_ANIM_MOVE_ON_WIRE_NET_RIGHT] = "CHAR_ANIM_MOVE_ON_WIRE_NET_RIGHT",
    [CHAR_ANIM_MOVE_ON_WIRE_NET_LEFT] = "CHAR_ANIM_MOVE_ON_WIRE_NET_LEFT",
    [CHAR_ANIM_MISSING_CAP] = "CHAR_ANIM_MISSING_CAP",
    [CHAR_ANIM_PULL_DOOR_WALK_IN] = "CHAR_ANIM_PULL_DOOR_WALK_IN",
    [CHAR_ANIM_PUSH_DOOR_WALK_IN] = "CHAR_ANIM_PUSH_DOOR_WALK_IN",
    [CHAR_ANIM_UNLOCK_DOOR] = "CHAR_ANIM_UNLOCK_DOOR",
    [CHAR_ANIM_START_REACH_POCKET] = "CHAR_ANIM_START_REACH_POCKET",
    [CHAR_ANIM_REACH_POCKET] = "CHAR_ANIM_REACH_POCKET",
    [CHAR_ANIM_STOP_REACH_POCKET] = "CHAR_ANIM_STOP_REACH_POCKET",
    [CHAR_ANIM_GROUND_THROW] = "CHAR_ANIM_GROUND_THROW",
    [CHAR_ANIM_GROUND_KICK] = "CHAR_ANIM_GROUND_KICK",
    [CHAR_ANIM_FIRST_PUNCH] = "CHAR_ANIM_FIRST_PUNCH",
    [CHAR_ANIM_SECOND_PUNCH] = "CHAR_ANIM_SECOND_PUNCH",
    [CHAR_ANIM_FIRST_PUNCH_FAST] = "CHAR_ANIM_FIRST_PUNCH_FAST",
    [CHAR_ANIM_SECOND_PUNCH_FAST] = "CHAR_ANIM_SECOND_PUNCH_FAST",
    [CHAR_ANIM_PICK_UP_LIGHT_OBJ] = "CHAR_ANIM_PICK_UP_LIGHT_OBJ",
    [CHAR_ANIM_PUSHING] = "CHAR_ANIM_PUSHING",
    [CHAR_ANIM_START_RIDING_SHELL] = "CHAR_ANIM_START_RIDING_SHELL",
    [CHAR_ANIM_PLACE_LIGHT_OBJ] = "CHAR_ANIM_PLACE_LIGHT_OBJ",
    [CHAR_ANIM_FORWARD_SPINNING] = "CHAR_ANIM_FORWARD_SPINNING",
    [CHAR_ANIM_BACKWARD_SPINNING] = "CHAR_ANIM_BACKWARD_SPINNING",
    [CHAR_ANIM_BREAKDANCE] = "CHAR_ANIM_BREAKDANCE",
    [CHAR_ANIM_RUNNING] = "CHAR_ANIM_RUNNING",
    [CHAR_ANIM_RUNNING_UNUSED] = "CHAR_ANIM_RUNNING_UNUSED",
    [CHAR_ANIM_SOFT_BACK_KB] = "CHAR_ANIM_SOFT_BACK_KB",
    [CHAR_ANIM_SOFT_FRONT_KB] = "CHAR_ANIM_SOFT_FRONT_KB",
    [CHAR_ANIM_DYING_IN_QUICKSAND] = "CHAR_ANIM_DYING_IN_QUICKSAND",
    [CHAR_ANIM_IDLE_IN_QUICKSAND] = "CHAR_ANIM_IDLE_IN_QUICKSAND",
    [CHAR_ANIM_MOVE_IN_QUICKSAND] = "CHAR_ANIM_MOVE_IN_QUICKSAND",
    [CHAR_ANIM_ELECTROCUTION] = "CHAR_ANIM_ELECTROCUTION",
    [CHAR_ANIM_SHOCKED] = "CHAR_ANIM_SHOCKED",
    [CHAR_ANIM_BACKWARD_KB] = "CHAR_ANIM_BACKWARD_KB",
    [CHAR_ANIM_FORWARD_KB] = "CHAR_ANIM_FORWARD_KB",
    [CHAR_ANIM_IDLE_HEAVY_OBJ] = "CHAR_ANIM_IDLE_HEAVY_OBJ",
    [CHAR_ANIM_STAND_AGAINST_WALL] = "CHAR_ANIM_STAND_AGAINST_WALL",
    [CHAR_ANIM_SIDESTEP_LEFT] = "CHAR_ANIM_SIDESTEP_LEFT",
    [CHAR_ANIM_SIDESTEP_RIGHT] = "CHAR_ANIM_SIDESTEP_RIGHT",
    [CHAR_ANIM_START_SLEEP_IDLE] = "CHAR_ANIM_START_SLEEP_IDLE",
    [CHAR_ANIM_START_SLEEP_SCRATCH] = "CHAR_ANIM_START_SLEEP_SCRATCH",
    [CHAR_ANIM_START_SLEEP_YAWN] = "CHAR_ANIM_START_SLEEP_YAWN",
    [CHAR_ANIM_START_SLEEP_SITTING] = "CHAR_ANIM_START_SLEEP_SITTING",
    [CHAR_ANIM_SLEEP_IDLE] = "CHAR_ANIM_SLEEP_IDLE",
    [CHAR_ANIM_SLEEP_START_LYING] = "CHAR_ANIM_SLEEP_START_LYING",
    [CHAR_ANIM_SLEEP_LYING] = "CHAR_ANIM_SLEEP_LYING",
    [CHAR_ANIM_DIVE] = "CHAR_ANIM_DIVE",
    [CHAR_ANIM_SLIDE_DIVE] = "CHAR_ANIM_SLIDE_DIVE",
    [CHAR_ANIM_GROUND_BONK] = "CHAR_ANIM_GROUND_BONK",
    [CHAR_ANIM_STOP_SLIDE_LIGHT_OBJ] = "CHAR_ANIM_STOP_SLIDE_LIGHT_OBJ",
    [CHAR_ANIM_SLIDE_KICK] = "CHAR_ANIM_SLIDE_KICK",
    [CHAR_ANIM_CROUCH_FROM_SLIDE_KICK] = "CHAR_ANIM_CROUCH_FROM_SLIDE_KICK",
    [CHAR_ANIM_SLIDE_MOTIONLESS] = "CHAR_ANIM_SLIDE_MOTIONLESS",
    [CHAR_ANIM_STOP_SLIDE] = "CHAR_ANIM_STOP_SLIDE",
    [CHAR_ANIM_FALL_FROM_SLIDE] = "CHAR_ANIM_FALL_FROM_SLIDE",
    [CHAR_ANIM_SLIDE] = "CHAR_ANIM_SLIDE",
    [CHAR_ANIM_TIPTOE] = "CHAR_ANIM_TIPTOE",
    [CHAR_ANIM_TWIRL_LAND] = "CHAR_ANIM_TWIRL_LAND",
    [CHAR_ANIM_TWIRL] = "CHAR_ANIM_TWIRL",
    [CHAR_ANIM_START_TWIRL] = "CHAR_ANIM_START_TWIRL",
    [CHAR_ANIM_STOP_CROUCHING] = "CHAR_ANIM_STOP_CROUCHING",
    [CHAR_ANIM_START_CROUCHING] = "CHAR_ANIM_START_CROUCHING",
    [CHAR_ANIM_CROUCHING] = "CHAR_ANIM_CROUCHING",
    [CHAR_ANIM_CRAWLING] = "CHAR_ANIM_CRAWLING",
    [CHAR_ANIM_STOP_CRAWLING] = "CHAR_ANIM_STOP_CRAWLING",
    [CHAR_ANIM_START_CRAWLING] = "CHAR_ANIM_START_CRAWLING",
    [CHAR_ANIM_SUMMON_STAR] = "CHAR_ANIM_SUMMON_STAR",
    [CHAR_ANIM_RETURN_STAR_APPROACH_DOOR] = "CHAR_ANIM_RETURN_STAR_APPROACH_DOOR",
    [CHAR_ANIM_BACKWARDS_WATER_KB] = "CHAR_ANIM_BACKWARDS_WATER_KB",
    [CHAR_ANIM_SWIM_WITH_OBJ_PART1] = "CHAR_ANIM_SWIM_WITH_OBJ_PART1",
    [CHAR_ANIM_SWIM_WITH_OBJ_PART2] = "CHAR_ANIM_SWIM_WITH_OBJ_PART2",
    [CHAR_ANIM_FLUTTERKICK_WITH_OBJ] = "CHAR_ANIM_FLUTTERKICK_WITH_OBJ",
    [CHAR_ANIM_WATER_ACTION_END_WITH_OBJ] = "CHAR_ANIM_WATER_ACTION_END_WITH_OBJ",
    [CHAR_ANIM_STOP_GRAB_OBJ_WATER] = "CHAR_ANIM_STOP_GRAB_OBJ_WATER",
    [CHAR_ANIM_WATER_IDLE_WITH_OBJ] = "CHAR_ANIM_WATER_IDLE_WITH_OBJ",
    [CHAR_ANIM_DROWNING_PART1] = "CHAR_ANIM_DROWNING_PART1",
    [CHAR_ANIM_DROWNING_PART2] = "CHAR_ANIM_DROWNING_PART2",
    [CHAR_ANIM_WATER_DYING] = "CHAR_ANIM_WATER_DYING",
    [CHAR_ANIM_WATER_FORWARD_KB] = "CHAR_ANIM_WATER_FORWARD_KB",
    [CHAR_ANIM_FALL_FROM_WATER] = "CHAR_ANIM_FALL_FROM_WATER",
    [CHAR_ANIM_SWIM_PART1] = "CHAR_ANIM_SWIM_PART1",
    [CHAR_ANIM_SWIM_PART2] = "CHAR_ANIM_SWIM_PART2",
    [CHAR_ANIM_FLUTTERKICK] = "CHAR_ANIM_FLUTTERKICK",
    [CHAR_ANIM_WATER_ACTION_END] = "CHAR_ANIM_WATER_ACTION_END",
    [CHAR_ANIM_WATER_PICK_UP_OBJ] = "CHAR_ANIM_WATER_PICK_UP_OBJ",
    [CHAR_ANIM_WATER_GRAB_OBJ_PART2] = "CHAR_ANIM_WATER_GRAB_OBJ_PART2",
    [CHAR_ANIM_WATER_GRAB_OBJ_PART1] = "CHAR_ANIM_WATER_GRAB_OBJ_PART1",
    [CHAR_ANIM_WATER_THROW_OBJ] = "CHAR_ANIM_WATER_THROW_OBJ",
    [CHAR_ANIM_WATER_IDLE] = "CHAR_ANIM_WATER_IDLE",
    [CHAR_ANIM_WATER_STAR_DANCE] = "CHAR_ANIM_WATER_STAR_DANCE",
    [CHAR_ANIM_RETURN_FROM_WATER_STAR_DANCE] = "CHAR_ANIM_RETURN_FROM_WATER_STAR_DANCE",
    [CHAR_ANIM_GRAB_BOWSER] = "CHAR_ANIM_GRAB_BOWSER",
    [CHAR_ANIM_SWINGING_BOWSER] = "CHAR_ANIM_SWINGING_BOWSER",
    [CHAR_ANIM_RELEASE_BOWSER] = "CHAR_ANIM_RELEASE_BOWSER",
    [CHAR_ANIM_HOLDING_BOWSER] = "CHAR_ANIM_HOLDING_BOWSER",
    [CHAR_ANIM_HEAVY_THROW] = "CHAR_ANIM_HEAVY_THROW",
    [CHAR_ANIM_WALK_PANTING] = "CHAR_ANIM_WALK_PANTING",
    [CHAR_ANIM_WALK_WITH_HEAVY_OBJ] = "CHAR_ANIM_WALK_WITH_HEAVY_OBJ",
    [CHAR_ANIM_TURNING_PART1] = "CHAR_ANIM_TURNING_PART1",
    [CHAR_ANIM_TURNING_PART2] = "CHAR_ANIM_TURNING_PART2",
    [CHAR_ANIM_SLIDEFLIP_LAND] = "CHAR_ANIM_SLIDEFLIP_LAND",
    [CHAR_ANIM_SLIDEFLIP] = "CHAR_ANIM_SLIDEFLIP",
    [CHAR_ANIM_TRIPLE_JUMP_LAND] = "CHAR_ANIM_TRIPLE_JUMP_LAND",
    [CHAR_ANIM_TRIPLE_JUMP] = "CHAR_ANIM_TRIPLE_JUMP",
    [CHAR_ANIM_FIRST_PERSON] = "CHAR_ANIM_FIRST_PERSON",
    [CHAR_ANIM_IDLE_HEAD_LEFT] = "CHAR_ANIM_IDLE_HEAD_LEFT",
    [CHAR_ANIM_IDLE_HEAD_RIGHT] = "CHAR_ANIM_IDLE_HEAD_RIGHT",
    [CHAR_ANIM_IDLE_HEAD_CENTER] = "CHAR_ANIM_IDLE_HEAD_CENTER",
    [CHAR_ANIM_HANDSTAND_LEFT] = "CHAR_ANIM_HANDSTAND_LEFT",
    [CHAR_ANIM_HANDSTAND_RIGHT] = "CHAR_ANIM_HANDSTAND_RIGHT",
    [CHAR_ANIM_WAKE_FROM_SLEEP] = "CHAR_ANIM_WAKE_FROM_SLEEP",
    [CHAR_ANIM_WAKE_FROM_LYING] = "CHAR_ANIM_WAKE_FROM_LYING",
    [CHAR_ANIM_START_TIPTOE] = "CHAR_ANIM_START_TIPTOE",
    [CHAR_ANIM_SLIDEJUMP] = "CHAR_ANIM_SLIDEJUMP",
    [CHAR_ANIM_START_WALLKICK] = "CHAR_ANIM_START_WALLKICK",
    [CHAR_ANIM_STAR_DANCE] = "CHAR_ANIM_STAR_DANCE",
    [CHAR_ANIM_RETURN_FROM_STAR_DANCE] = "CHAR_ANIM_RETURN_FROM_STAR_DANCE",
    [CHAR_ANIM_FORWARD_SPINNING_FLIP] = "CHAR_ANIM_FORWARD_SPINNING_FLIP",
    [CHAR_ANIM_TRIPLE_JUMP_FLY] = "CHAR_ANIM_TRIPLE_JUMP_FLY",
}


local PALETTE_PDOB = {
    [PANTS] = "3C7CA8",
    [SHIRT] = "3C7CA8",
    [GLOVES] = "FFFFFF",
    [SHOES] = "FFFFFF",
    [HAIR] = "000000",
    [SKIN] = "FFFFFF",
    [CAP] = "3C7CA8",
    [EMBLEM] = "3C7CA8"
}

local  METER_PDOB = {
    label = {
        left = get_texture_info("pdobhl"),
        right = get_texture_info("pdobhr"),
    },
    pie = {
        [1] = get_texture_info("dob1"),
        [2] = get_texture_info("dob2"),
        [3] = get_texture_info("dob3"),
        [4] = get_texture_info("dob4"),
        [5] = get_texture_info("dob5"),
        [6] = get_texture_info("dob6"),
        [7] = get_texture_info("dob7"),
        [8] = get_texture_info("dob8"),
    }
}

if _G.charSelectExists then
    _G.CT_PDOB = _G.charSelect.character_add("DOB", {"That's right, it's DOB!", "The silliest cosmic sheriff ever."}, "denpakei32/PeachyPeach (face swapping code)", {r = 38, g = 90, b = 222}, E_MODEL_PDOB, CT_MARIO, TEX_PDOB_ICON, 1, 0)

function anifacsync(m)
    local animID = m.marioObj.header.gfx.animInfo.animID

    if animID == CHAR_ANIM_RETURN_STAR_APPROACH_DOOR or 
       animID == CHAR_ANIM_STAR_DANCE or 
       animID == CHAR_ANIM_WATER_STAR_DANCE or
       animID == CHAR_ANIM_SLIDE_MOTIONLESS or
       animID == CHAR_ANIM_UNLOCK_DOOR or
       animID == CHAR_ANIM_JUMP_RIDING_SHELL or
       animID == CHAR_ANIM_FAST_LONGJUMP or
       animID == CHAR_ANIM_SLOW_LONGJUMP or
       animID == CHAR_ANIM_TRIPLE_JUMP or
       animID == CHAR_ANIM_TRIPLE_JUMP_FLY or
       animID == CHAR_ANIM_TRIPLE_JUMP_LAND or      
       animID == CHAR_ANIM_CREDITS_WAVING then

        m.marioBodyState.eyeState = MARIO_EYES_LOOK_DOWN

    elseif animID == CHAR_ANIM_COUGHING or
           animID == CHAR_ANIM_BACKWARD_AIR_KB or
           animID == CHAR_ANIM_AIR_FORWARD_KB or
           animID == CHAR_ANIM_SOFT_BACK_KB or
           animID == CCHAR_ANIM_SOFT_FRONT_KB or
           animID == CHAR_ANIM_BACKWARD_KB or
           animID == CHAR_ANIM_FOWARD_KB or
           animID == CHAR_ANIM_BACKWARDS_WATER_KB or
           animID == CHAR_ANIM_ELECTROCUTION or
           animID == CHAR_ANIM_WATER_FORWARD_KB then
        m.marioBodyState.eyeState = MARIO_EYES_LOOK_LEFT

    elseif animID == CHAR_ANIM_SUFFOCATING or 
           animID == CHAR_ANIM_DYING_ON_BACK or 
           animID == CHAR_ANIM_DYING_ON_STOMACH or 
           animID == CHAR_ANIM_DYING_FALL_OVER or 
           animID == CHAR_ANIM_DYING_IN_QUICKSAND or 
           animID == CHAR_ANIM_WALK_PANTING or
           animID == CHAR_ANIM_HEAD_STUCK_IN_GROUND or
           animID == CHAR_ANIM_BOTTOM_STUCK_IN_GROUND or
           animID == CHAR_ANIM_LEGS_STUCK_IN_GROUND or
           animID == CHAR_ANIM_WATER_DYING then

        m.marioBodyState.eyeState = MARIO_EYES_DEAD

    elseif animID == CHAR_ANIM_SWINGING_BOWSER or 
           animID == CHAR_ANIM_RELEASE_BOWSER or
           animID == CHAR_ANIM_GRAB_BOWSER or
           animID == CHAR_ANIM_GROUND_POUND or
           animID == CHAR_ANIM_GROUND_POUND_LANDING or
           animID == CHAR_ANIM_FIRST_PUNCH or
           animID == CHAR_ANIM_SECOND_PUNCH or
           animID == CHAR_ANIM_FIRST_PUNCH_FAST or
           animID == CHAR_ANIM_SECOND_PUNCH_FAST or
           animID == CHAR_ANIM_HEAVY_THROW or
           animID == CHAR_ANIM_HOLDING_BOWSER then

        m.marioBodyState.eyeState = MARIO_EYES_LOOK_RIGHT

    elseif animID == CHAR_ANIM_FALL_FROM_SLIDE or
           animID == CHAR_ANIM_SLOW_LEDGE_GRAB or
           animID == CHAR_ANIM_FAST_LEDGE_GRAB or
           animID == CHAR_ANIM_IDLE_ON_LEDGE or
           animID == CHAR_ANIM_FIRE_LAVA_BURN or
           animID == CHAR_ANIM_GENERAL_FALL then
        m.marioBodyState.eyeState = MARIO_EYES_LOOK_UP

    else
        m.marioBodyState.eyeState = MARIO_EYES_OPEN
    end
end

hook_event(HOOK_MARIO_UPDATE, anifacsync)

--[[
MARIO_EYES_OPEN
MARIO_EYES_LOOK_LEFT
MARIO_EYES_LOOK_RIGHT
MARIO_EYES_LOOK_UP
MARIO_EYES_LOOK_DOWN
MARIO_EYES_DEAD
]]

--   _G.charSelect.dialog_set_replace_name(DOB)
-- apparently not implemented yet
    _G.charSelect.character_add_voice(E_MODEL_PDOB, VOICETABLE_PDOB)
    _G.charSelect.character_add_caps(E_MODEL_PDOB, CAP_PDOB)
    _G.charSelect.character_add_palette_preset(E_MODEL_PDOB, PALETTE_PDOB)
    _G.charSelect.character_add_health_meter(CT_PDOB, METER_PDOB)

    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_PDOB then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_PDOB then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end
